from multiprocessing import Process, Queue, Lock
import numpy as np
from prob_cond_true_freq import prob_cond_true_freq
from comp_emit_BF_3_SEG import comp_emit_BF_3_SEG
from proba_nielsen import proba_nielsen
import time

class A:
    "class A"
    def __init__(self):
        self.list_chro = []
        self.list_pos = []
        self.list_E = []
    #...
#...

#function that sort a list of A object by the list_pos[0]
def quickSort(L):
 
    def trirap(L, g, d):
        pivot = L[(g+d)//2].list_pos[0]
        i = g
        j = d
        while True:
            while L[i].list_pos[0]<pivot:
                i+=1
            while L[j].list_pos[0]>pivot:
                j-=1
            if i>j:
                break
            if i<j:
                L[i], L[j] = L[j], L[i]
            i+=1
            j-=1
        if g<j:
            trirap(L,g,j)
        if i<d:
            trirap(L,i,d)
 
    g=0
    d=len(L)-1
    trirap(L,g,d)
#...

#function that is parallelized
def procress_emit(qinput,qoutput,lock,pileup_prefix,min_count,min_minor,n,p_neutral,f_sel1,f_sel2,ancestral):
    pileup = open(pileup_prefix+'.in', 'r')
    for item in iter(qinput.get,'STOP'):
        l = []
        pileup.seek(item[0])
        for i in range(item[1]):
            l.append(pileup.readline())
        #...
        res = A()
        for l_item in l:
            buf=l_item.split()
	    nder=int(buf[2])
	    ntot=int(buf[3])
	    unfolded=(1-int(buf[4]))*(ancestral=='provided')
            if ntot >= min_count and nder >= min_minor and (ntot-nder) >= min_minor:
                p = prob_cond_true_freq(n,nder,ntot,unfolded);
		E = comp_emit_BF_3_SEG(p,p_neutral,f_sel1,f_sel2)
		if E[0] > 0 and E[1] > 0 and E[2] > 0:                  	
                    res.list_chro.append(buf[0])
                    res.list_pos.append(int(buf[1]))
                    res.list_E.append(E)
                #...
            #...
        #...
        if len(res.list_E) != 0: #in case that all the lines parsed are not valid 
            qoutput.put(res)
        #...
    #...
    pileup.close()
#...

def comp_emit_seg_direct(min_count,min_minor,region,nProcess,n,prefix,p_neutral,pileup_prefix,ancestral):
    
    emit = open(prefix + '.segemit','w')
    lock = Lock()
    task_queue = Queue()
    done_queue = Queue()
    block = 10000
    pileup = open(pileup_prefix+'.in', 'rb')

    # computation of cond prob for segsites
    if region:
        chro = region[0]
        start = region[1]
        end = region[2]
        offset_default = pileup.tell()
        pileup_line = pileup.readline()
        a = pileup_line.split()[0]
        while(a != chro):
            offset_default = pileup.tell()
            pileup_line = pileup.readline()
            try:
                a = pileup_line.split()[0]
            except IndexError:
                #if the pileup_line can't be splited, that's the end of the file
                print ('ERROR : chro %s not found' % (chro))
                sys.exit()
            #...
        #...
        if start:
            a = int(pileup_line.split()[1])
            b = pileup_line.split()[0]
            if a > end:
                print ('ERROR : interval\'s positions not found.')
                sys.exit()
            #...
            while a < start and b == chro:
                offset_default = pileup.tell()
                pileup_line = pileup.readline()
                try:
                    a = int(pileup_line.split()[1])
                    b = pileup_line.split()[0]
                except IndexError:
                    #if the pileup_line can't be splited, that's the end of the file
                    print ('ERROR : interval\'s positions not found.')
                #...
            #...
            if b != chro:
                print b
                print ('ERROR : interval\'s positions not found.')
                sys.exit()
        #...
        offset_table = [offset_default]
        nbLine = 0
        split_pileup = pileup_line.split()
        while split_pileup[0] == chro:
            if start:
                if int(split_pileup[1]) > end:
                    break
                #...
             #...
            nbLine += 1
            if nbLine % block == 0:
                offset_table.append(pileup.tell())
            #...
            pileup_line = pileup.readline()
            split_pileup = pileup_line.split()
            if len(split_pileup) == 0:
                break
            #... 
        #...
    #...
    else:
        offset_table = [0]
        nbLine = 0
        pileup_line = pileup.readline()
        while(pileup_line != ''): #if pileup_line == '', that's the end of the file
            nbLine += 1
            if nbLine % block == 0:
                offset_table.append(pileup.tell())
            #...
            pileup_line = pileup.readline()
        #...
    #...
    pileup.close()
    coeff1 = 0.5 # 0.7
    coeff2 = 0.1 # 0.2
    f_sel1 = proba_nielsen(n,p_neutral,coeff1)
    print ('f_sel1 loaded')
    f_sel2 = proba_nielsen(n,p_neutral,coeff2)
    print ('f_sel2 loaded')
    
    # shrinks distributions
    if min_minor>0:
	for i in range(min_minor):
	    p_neutral[i]=0
	    p_neutral[n-i]=0
	    f_sel1[i]=0
	    f_sel1[n-i]=0
	    f_sel2[i]=0
	    f_sel2[n-i]=0
	p_neutral /= np.sum(p_neutral)
	f_sel1 /= np.sum(f_sel1)
	f_sel2 /= np.sum(f_sel2)
	
    for i in range(nProcess):
        p = Process(target=procress_emit,args=(task_queue,done_queue,lock,pileup_prefix,min_count,min_minor,n,p_neutral,f_sel1,f_sel2,ancestral)).start()
    #...
    
    #for each offset expept the last one
    for offset in offset_table[:-1]:
        task_queue.put([offset,block])
    #...
    
    #management of the last line_block 
    if nbLine % block != 0:
        task_queue.put([offset_table[-1],nbLine % block])
    #...
    del offset_table
    del f_sel1
    del f_sel2
    
    for i in range(nProcess):
        task_queue.put('STOP')
    #...
    while task_queue.qsize() != 0:
        pass
    #...
    mat = []
    for i in range(done_queue.qsize()):
        mat.append(done_queue.get())
    #...
    if len(mat) > 1:
        quickSort(mat)
    #...

    for item in mat:
        for i in range(len(item.list_pos)):
            emit.write( item.list_chro[i] + ' ' + str(item.list_pos[i]) + ' ' + str(item.list_E[i][0]) + ' ' + str(item.list_E[i][1]) + ' ' + str(item.list_E[i][2]) + '\n')
        #...
    #...
    emit.close()
#...
