import numpy as np
from scipy.stats import hypergeom

def prob_cond_true_freq(n,nder,ntot,unfolded):
    #n: sample size 
    #nder: nb of derived or minor alleles
    # ntot: nb of observed alleles
    #unfolded: 1 if unfolded, 0 else.
    #p: conditional prob of v0 given n,nder,ntot,unfolded. size n+1*1
    p = np.zeros(n+1,'float')
    if ntot==n:
	if (unfolded==1):
	    p[nder]=1
	else:
	    p[nder]=0.5
	    p[n-nder]=0.5
    else:
    	if (unfolded==1):
	    for i in range(1,n+1):
	    	p[i]=hypergeom.pmf(nder,n,i,ntot)
	    if nder==0:
	    	p[0]=1
    	else:
	    for i in range(1,n+1):
            	p[i] = (hypergeom.pmf(nder,n,i,ntot) + hypergeom.pmf(ntot-nder,n,i,ntot))/2
	    if nder==0 or nder==ntot:
	    	p[i]=0.5
    #...
    return p
#...

